<!DOCTYPE html>
<html lang="fr">

<head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>

    <title>Vote - Polysphères</title>
    <meta name="description" content="Votez pour les Polysphères de cette année !">

    <link rel="stylesheet" href="https://unpkg.com/vue-agile/dist/VueAgile.css">
    <!-- Google Icon Font + CSS -->
    <link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/css/materialize.min.css">
    <style type="text/css">
        [v-cloak] {
            display: none;
        }

        .agile__actions {
            display: none;
        }
    </style>
</head>

<body>
<nav class="blue lighten-2">
    <div class="nav-wrapper container">
        <a class="breadcrumb" href="/">Login</a>
        <a class="breadcrumb" href="/home">Vote</a>
    </div>
</nav>
<div class="container" id="app"><br/>
    <div class="row">
        <div class="center" v-if="tequila" v-cloak>
            <p class="flow-text">Vous êtes identifié·e en tant que <b>{{ tequila.name }} ({{ tequila.sciper }})</b>
            </p>
        </div>
        <div class="card-panel red lighten-2" v-if="error_message" v-cloak>
                <span class="white-text"><b style="padding:6px;">Une erreur s'est produite :</b>{{ error_message }}
                </span>
        </div>
    </div>
    <div class="row">
        <div class="col s12 m6">
            <div class="card">
                <div class="card-image">
                    <agile autoplay infinite navButtons="false">
                        <div class="slide">
                            <img src="/pics/slide-1.jpg" />
                        </div>
                        <div class="slide">
                            <img src="/pics/slide-2.jpg" />
                        </div>
                        <div class="slide">
                            <img src="/pics/slide-3.jpg" />
                        </div>
                        <div class="slide">
                            <img src="/pics/slide-4.jpg" />
                        </div>
                        <div class="slide">
                            <img src="/pics/slide-5.jpg" />
                        </div>
                        <div class="slide">
                            <img src="/pics/slide-6.jpg" />
                        </div>
                        <div class="slide">
                            <img src="/pics/slide-7.jpg" />
                        </div>
                        <div class="slide">
                            <img src="/pics/slide-8.jpg" />
                        </div>
                        <div class="slide">
                            <img src="/pics/slide-9.jpg" />
                        </div>
                    </agile>

                    <span class="card-title"><b>Les Polysphères</b></span>
                </div>
                <div class="card-content">
                    <p>Chaque année, les étudiant·e·s ont l’occasion de désigner le·a professeur·e qui, selon
                        eux·elles, a le plus de mérite. Le·a professeur·e récoltant le plus de voix recevra la «
                        Polysphère d’Or », le prix des étudiant·e·s, soutenu
                        par la Vice Présidence Académique de l’EPFL. Un prix est également décerné au/à la premier·ère
                        professeur·e élu·e de chaque faculté.</p><br/>
                    <p>Parmi toutes les distinctions auxquelles peuvent prétendre les professeur·e·s, pour leurs
                        recherches, leurs publications, leurs découvertes, il est important de ne pas négliger ce
                        volet si important de leur carrière qu’est l’enseignement.
                        La pédagogie, l’écoute, le temps consacré et le partage du savoir ne sont qu’un aperçu des
                        qualités précieuses qui font un·e excellent·e professeur·e.</p><br/>
                    <p>Les prix sont remis lors de la Magistrale (cérémonie de remise des diplômes et des prix),
                        chaque automne.</p>
                </div>
                <div class="card-action">
                    <a href="https://agepoly.ch/polyspheres/">En savoir plus</a>
                </div>
            </div>
        </div>
        <div class="col s12 m6">
            <div class="card-panel" v-if="!voted" v-cloak>
                <form action="/vote" method="post" @submit.prevent="submitForm" id="votef">
                    <div class="row">
                        <p class="center">Votre choix n°1</p>
                        <div class="input-field col s12">
                            <i class="material-icons prefix">face</i>
                            <multiselect v-model="p1" :options="filtOptions" :internal-search="false"
                                         @search-change="caseSensitiveOptions" :custom-label="displayName"
                                         :show-no-results="false" :hide-selected="true" :limit="3" :options-limit="60"
                                         placeholder="Nom du ou de la professeur·e" label="name" track-by="name"
                                         class="autocomplete-content"></multiselect>
                        </div>
                        <div class="input-field col s12">
                                <textarea form="votef" name="m1" id="m1" v-model="m1"
                                          class="materialize-textarea"></textarea>
                            <label for="m1">Une brève explication de ce choix (facultative)</label>
                        </div>
                    </div>
                    <div class="row">
                        <p class="center">Votre choix n°2</p>
                        <div class="input-field col s12">
                            <i class="material-icons prefix">face</i>
                            <multiselect v-model="p2" :options="filtOptions" :internal-search="false"
                                         @search-change="caseSensitiveOptions" :custom-label="displayName"
                                         :show-no-results="false" :hide-selected="true" :limit="3" :options-limit="60"
                                         placeholder="Nom du ou de la professeur·e" label="name" track-by="name"
                                         class="autocomplete-content"></multiselect>
                        </div>
                        <div class="input-field col s12">
                                <textarea form="votef" id="m2" name="m2" v-model="m2"
                                          class="materialize-textarea"></textarea>
                            <label for="m2">Une brève explication de ce choix (facultative)</label>
                        </div>
                    </div>
                    <div class="row">
                        <p class="center">Votre choix n°3</p>
                        <div class="input-field col s12">
                            <i class="material-icons prefix">face</i>
                            <multiselect v-model="p3" :options="filtOptions" :internal-search="false"
                                         @search-change="caseSensitiveOptions" :custom-label="displayName"
                                         :show-no-results="false" :hide-selected="true" :limit="3" :options-limit="60"
                                         placeholder="Nom du ou de la professeur·e" label="name" track-by="name"
                                         class="autocomplete-content"></multiselect>
                        </div>
                        <div class="input-field col s12">
                                <textarea form="votef" id="m3" name="m3" v-model="m3"
                                          class="materialize-textarea"></textarea>
                            <label for="m3">Une brève explication de ce choix (facultative)</label>
                        </div>
                    </div>
                    <br/>
                    <button class="btn blue lighten-2 waves-effect waves-light" type="submit"
                            name="action">Envoyer
                        <i class="material-icons right">send</i>
                    </button>
                </form>
            </div>
            <div class="card-panel" v-if="voted" v-cloak>
                Ton vote a été enregistré. Merci de ta participation et à l'année prochaine :)
            </div>
        </div>
    </div>
</div>


<!--Scripts -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/js/materialize.min.js"></script>
<!-- <script src="https://unpkg.com/vue/dist/vue.global.prod.js" crossorigin="anonymous"></script> -->
<script src="https://cdn.jsdelivr.net/npm/vue@2.6.14/dist/vue.js"></script>
<script src="https://unpkg.com/vue-cookies@1.7.4/vue-cookies.js" crossorigin="anonymous"></script>
<script src="https://unpkg.com/jwt-decode@2.2.0/build/jwt-decode.min.js" crossorigin="anonymous"></script>
<script src="https://unpkg.com/vue-multiselect@2.1.0"></script>
<script src="https://unpkg.com/vue-agile@1.0.5"></script>
<link rel="stylesheet" href="https://unpkg.com/vue-multiselect@2.1.0/dist/vue-multiselect.min.css">
<script src="https://cdnjs.cloudflare.com/ajax/libs/axios/0.19.2/axios.min.js"
        integrity="sha512-VZ6m0F78+yo3sbu48gElK4irv2dzPoep8oo9LEjxviigcnnnNvnTOJRSrIhuFk68FMLOpiNz+T77nNY89rnWDg=="
        crossorigin="anonymous"></script>


<script>
  axios.defaults.headers.common['X-Requested-With'] = 'XMLHttpRequest'
  axios.default.withCredentials = true
  Vue.component('vue-multiselect', window.VueMultiselect.default)

  Vue.use(window.VueAgile)

  let app = new Vue({
    el: '#app',
    components: {
      'multiselect': window.VueMultiselect.default,
      agile: window.VueAgile
    },
    data: {
      tequila: jwt_decode($cookies.get('tequila')),
      voted: $cookies.get('voted'),
      p1: '',
      p2: '',
      p3: '',
      m1: '',
      m2: '',
      m3: '',
      error_message: undefined,
      error_timeout: undefined,
      options: [],
      filtOptions: []
    },
    mounted: function () {
      axios.get('/candidates', {
        params: {}
      }, {
        withCredentials: true
      })
        .then(reply => reply.data)
        .then(data => {
          //shuffle
          this.options = data.sort(() => Math.random() - 0.5)
          this.caseSensitiveOptions("")
        })
        .catch(err => {
          this.displayError('Erreur lors du traitement de la liste des candidats.')
        })

    },

    methods: {
      submitForm (e) {
        window.scrollTo({
          top: 0,
          behavior: 'smooth'
        })
        if (!this.p1 || this.p1 === '' || !this.p1.id) {
          this.displayError('Vous n\'avez pas de premier candidat')
          return
        }
        if (!this.p2 || this.p2 === '' || !this.p2.id) {
          this.displayError('Vous n\'avez pas de deuxieme candidat')
          return
        }
        if (!this.p3 || this.p3 === '' || !this.p3.id) {
          this.displayError('Vous n\'avez pas de troisième candidat')
          return
        }
        if (this.p1.id === this.p2.id ||
          this.p1.id === this.p3.id ||
          this.p2.id === this.p3.id) {
          this.displayError('Vous ne pouvez pas voter plusieures fois pour le même candidat.')
          return
        }

        return axios.get('/vote', {
          params: {
            p1: this.p1.id,
            p2: this.p2.id,
            p3: this.p3.id,
            m1: this.m1,
            m2: this.m2,
            m3: this.m3
          }
        }, {
          withCredentials: true
        })
          .then(reply => reply.data)
          .then(data => {
            this.voted = $cookies.get('voted')
          })
          .catch(err => {
            this.displayError('Erreur lors de la soumission du vote.')
            this.voted = $cookies.get('voted')
          })

      },
      displayName ({
        name,
        id
      }) {
        return name
      },
      displayError (message) {
        clearTimeout(this.error_timeout)
        this.error_message = message
        this.error_timeout = setTimeout(() => {
          this.error_message = undefined
        }, 5000)
      },
      removeDiacritics (text) {
        return text.normalize('NFD').replace(/[\u0300-\u036f]/g, '')
      },
      normalizedContains (text, newText) {
        const regExp = new RegExp(this.removeDiacritics(text), 'gi')
        return regExp.test(this.removeDiacritics(newText))
      },
      caseSensitiveOptions (search) {
        this.filtOptions = search
          ? this.options.filter(option => this.normalizedContains(search, option.name))
          : this.options
      }

    },
    computed: {
      AvailableOptions () {
        return this.filtOptions.filter(v => !((this.p1 && this.p1.id == v.id) ||
          (this.p2 && this.p2.id == v.id) ||
          (this.p3 && this.p3.id == v.id)))
      }
    }
  })
</script>
</body>

</html>
